// Funciones de Ratatui

/**-	FunciÃ³n auxiliar para encontrar elementos del documento por su identificador (id).
 	@param id El identificador del elemento a buscar.
**/
function $(id){
	return document.getElementById(id);
}

/**	@class Remy Clase Remy con la funcionalidad para las pruebas.
**/
var Remy = {							// Es una "clase estÃ¡tica".
	debugar: false,
	test: null,						// Array que contendrÃ¡ las lÃ­neas del test.
	resultado: true,					// Booleano indicando si hubo fallos en la ejecuciÃ³n.
	iframeCargado: false,					// Ãndica si estÃ¡ cargada el iframe.
	esperarACargar: 0,
	indice: null,
	pararEjecucion: false,

	/**	@fn ejecutar FunciÃ³n principal que ejecuta el script de pruebas.
		El script se ejecuta desde el punto en el que se detuvo la Ãºltima vez (ver esperar).
	**/
	ejecutar: function (){
		Remy.debug("En ejecutar");
		Remy.pararEjecucion = false;
		if (Remy.test == null) return;					// TodavÃ­a no se ha cargado.
		while ((Remy.indice < Remy.test.length) && !Remy.pararEjecucion){
			if (Remy.test[Remy.indice].match(/(^\s*$)|(^\/\/)/) == null){
				Remy.debug("Ejecutando "+Remy.test[Remy.indice]);
				eval("Remy."+Remy.test[Remy.indice]);
			}
			Remy.indice++;
		}
	},
	/**-	Carga el fichero JS que indique el usuario.
		@param fichero Path al fichero JS.
	**/
	cargarJS: function (fichero){
		Remy.debug("CargandoJS("+fichero+")");
		var head = document.getElementsByTagName('head')[0];
		var script = document.createElement('script');
		script.src = fichero;
		script.type = 'text/javascript';
		head.appendChild(script);
		Remy.esperar();
	},
	/**-	Carga una URL en la iframe de Ratatui.
		@param URL La URL de la ventana a cargar.
	**/
	cargar: function(URL){
		Remy.debug("Cargando("+URL+")");
		Remy.iframeCargado = false;
		$('iframe').src = URL;
		Remy.esperarCarga();
	},
	/**-	Devuelve el cÃ³digo fuente de la pÃ¡gina cargada.
	**/
	verPagina: function(){
		var html = $('iframe').contentDocument.getElementsByTagName("html")[0].innerHTML;
		//html = html.replace(/\"/g,'#');
		//html = html.replace(/\n/g,'');
		return html;
	},
	/**-	Devuelve el cÃ³digo fuente de la pÃ¡gina cargada codificado en MD5.
		Al cÃ³digo fuente le sustituye las comillas dobles y eliminamos los retornos de carro.
		De esta forma, el cÃ³digo puede copiarse y pegarse para compararse con el resultado de la funciÃ³n cargar.
	**/
	verPaginaMD5: function(){
		var html = $('iframe').contentDocument.getElementsByTagName("html")[0].innerHTML;
		return Remy.md5(html);
	},
	/**-	Escribe un mensaje en la salida.
		@param mensaje Texto del mensaje a escribir.
	**/
	mensaje: function(mensaje){
		var texto = document.createTextNode(mensaje);
		var p = document.createElement("p");
		p.appendChild(texto);
		$('fieldsetResultados').appendChild(p);
	},
	/**-	Comprueba que dos valores son iguales y escribe el resultado como test.
		@param val1 Primer valor a comparar.
		@param val2 Segundo valor a comparar.
		@param	mensaje Texto que se escribirÃ¡ en la salida del test.
	**/
	probarIgual: function(val1, val2, mensaje){
		resultado = false;
		if (val1 == val2) resultado = true;
		if (!resultado){
			Remy.resultado = false;
			mensajeResultado = " -> NOK\n("+val1+" != "+val2+")";
		}
		else 
			mensajeResultado = " -> OK";
		var texto = document.createTextNode(mensaje + mensajeResultado);
		var p = document.createElement("p");
		p.appendChild(texto);
		$('fieldsetResultados').appendChild(p);
		return resultado;
	},
	/**-	Comprueba el valor md5 de la pÃ¡gina actual.
		@param md5 Valor md5 a comprobar.
		@param	mensaje Texto que se escribirÃ¡ en la salida del test.
	**/
	probarMD5Pagina: function(md5, mensaje){
		return Remy.probarIgual(Remy.verPaginaMD5(), md5, mensaje);
	},
	/**-	Devuelve la codificaciÃ³n md5 de un texto.
		@param texto Texto para codificar.
	**/
	md5: function(texto){
		return hex_md5(texto);
	},
	/**-	Espera el nÃºmero de segundos indicado.
		La espera se realiza deteniendo la ejecuciÃ³n durante el tiempo indicado.
		@param segundos Tiempo de la espera.
	**/
	esperar: function(segundos){
		if (arguments.length == 0) segundos = 2;	//Tiempo de espera por defecto.
		Remy.pararEjecucion = true;	//Para que no siga ejecutando y espere...
		window.setTimeout('Remy.ejecutar()', segundos*1000);
		/*
		var peticiÃ³n = new XMLHttpRequest();
		peticiÃ³n.open("POST", Remy.URL_ESPERAR_PHP, false);
		peticiÃ³n.setRequestHeader("Content-Type", "application/x-www-form-urlencoded; charset=utf-8");
		var mensaje = "&retardo="+segundos;
		peticiÃ³n.send(mensaje);
		return;
		*/
	},
	/**-	Espera la carga del iframe y continua la ejecuciÃ³n del test o, si no estÃ¡ cargado, lo parsea.
	**/
	esperarCarga: function(){
		if(!Remy.iframeCargado){
			Remy.pararEjecucion = true;	//Para que no siga ejecutando y espere...
			Remy.debug("Esperando la carga...");
			window.setTimeout('Remy.esperarCarga()', 2*1000);
		}
		else{
			Remy.debug("Â¡Cargado!");
			if (Remy.indice == null){
				Remy.debug("Parseando...");
				Remy.parsear();
			}
			else {
				Remy.debug("Reanudando ejecuciÃ³n.");
				Remy.ejecutar();
			}
		}
	},
	/**-	Prepara el cÃ³digo de la prueba para que pueda ser ejecutado.
	**/
	parsear: function(){
		var codigo = $('iframe').contentDocument.getElementsByTagName("pre")[0].firstChild.nodeValue;	//Vale, parece raro y complicado, pero ahÃ­ estÃ¡ el cÃ³digo cargado (ver DOM Inspector).
		Remy.test = codigo.split("\n");	// Separamos las lÃ­neas por retornos de carro.
		Remy.indice = 0;
		Remy.debug("Fin del parseo");
		Remy.ejecutar();
	},
	ponerValor: function(elemento, valor){
		$('iframe').contentDocument.getElementById(elemento).value = valor;
	},
	debug: function(mensaje){
		if (Remy.debugar) Remy.mensaje(mensaje);
	},
	/**-	Lanza el evento "click" al objeto indicado.
		@param idBoton Identificador del objeto al que lanzar el evento.
	**/
	pulsar: function(idBoton){
		var boton = $('iframe').contentDocument.getElementById(idBoton);
		if (!boton) return
		else boton.click();
	}
	//No olivdes quitar la coma del Ãºltimo elemento de la enumeraciÃ³n.
};

//Remy.cargarJS("js/md5.js");		//Cargamos la librerÃ­a para utilizar md5
